<!-- Copyright 2021 Karlsruhe Institute of Technology
   -
   - Licensed under the Apache License, Version 2.0 (the "License");
   - you may not use this file except in compliance with the License.
   - You may obtain a copy of the License at
   -
   -     http://www.apache.org/licenses/LICENSE-2.0
   -
   - Unless required by applicable law or agreed to in writing, software
   - distributed under the License is distributed on an "AS IS" BASIS,
   - WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   - See the License for the specific language governing permissions and
   - limitations under the License. -->

<template>
  <div>
    <span class="mr-2">{{ title }}</span>
    <input class="form-control d-inline input" type="number" v-model.number="value" @pointerdown.stop>
  </div>
</template>

<style scoped>
.input {
  width: 70px;
}
</style>

<script>
import {InputControlMixin} from 'core';

export default {
  mixins: [InputControlMixin],
  props: {
    title: String,
    defaultValue: Number,
  },
  methods: {
    validateValue() {
      if (isNaN(this.value)) {
        this.value = this.defaultValue;
      } else if (this.value > 99) {
        this.value = 99;
      } else if (this.value < 0) {
        this.value = 0;
      } else {
        this.value = Math.floor(this.value);
      }
    },
  },
};
</script>
